let operator;
let url;
let updatedData;
let returnPage;
let uploadFiles;
let utilizeNewId;

(function (webapi, $) {
    function safeAjax(ajaxOptions) {
        var deferredAjax = $.Deferred();

        shell.getTokenDeferred().done(function (token) {
            // add headers for AJAX
            if (!ajaxOptions.headers) {
                $.extend(ajaxOptions, {
                    headers: {
                        "__RequestVerificationToken": token
                    }
                });
            } else {
                ajaxOptions.headers["__RequestVerificationToken"] = token;
            }
            $.ajax(ajaxOptions)
                .done(function (data, textStatus, jqXHR) {
                    validateLoginSession(data, textStatus, jqXHR, deferredAjax.resolve);
                }).fail(deferredAjax.reject); //AJAX
        }).fail(function () {
            deferredAjax.rejectWith(this, arguments); // on token failure pass the token AJAX and args
        });

        return deferredAjax.promise();
    }
    webapi.safeAjax = safeAjax;
})(window.webapi = window.webapi || {}, jQuery)

function createRecord(newOperator, newUrl, newData, newQuery) {
    operator = newOperator;
    url = newUrl;
    updatedData = newData;
    returnPage = newReturnPage;
    query = newQuery;

    webapi.safeAjax({
        type: operator,
        contentType: "application/json",
        url: url,
        data: updatedData,
        success: function (data, textStatus, xhr) {
            console.log("Record updated");
            ajaxSuccessCallback(data, textStatus, xhr);
        },
        error: function (xhr, textStatus, errorThrown) {
            console.log(xhr);
        }
    })
}

function updateRecord(newUrl, newData, newQuery) {
    url = newUrl;
    updatedData = newData;
    returnPage = newReturnPage;
    query = newQuery;

    webapi.safeAjax({
        type: "PATCH",
        contentType: "application/json",
        url: url,
        data: updatedData,
        success: function (data, textStatus, xhr) {
            console.log("Record updated");
            ajaxSuccessCallback(data, textStatus, xhr);
        },
        error: function (xhr, textStatus, errorThrown) {
            console.log(xhr);
            ajaxErrorCallback(xhr);
        }
    })
}

function retrieveMultiple(uri, filter) {
    query = uri + filter;
    webapi.safeAjax({
        type: "GET",
        url: query,
        contentType: "application/json",
        headers: {
            "Prefer": "odata.include-annotations=*"
        },
        success: function (data, textStatus, xhr) {
            var results = data;
            console.log(results);
            return results;
        },
        error: function (xhr, textStatus, errorThrown) {
            console.log(xhr);
        }
    });
}

function ajaxSuccessCallback(data, textStatus, xhr) {
    let id = xhr.getResponseHeader("entityid");
    console.info(`Record was created with id ${id}.`);
    let newId = utilizeNewId ? '&id=' + id : '';
}

function ajaxErrorCallback(result) {
    console.error(`ajax call failed: ${JSON.stringify(result)}`);
    // alert("ajax call failed check console for more information.");
}